//
//  WriteBarCode.h
//  BarCodeFramework
//
//  Created by Yogesh Arora on 14/12/12.
//  Copyright (c) 2012 __MyCompanyName__. All rights reserved.
//

/*
 This class will write the BarCode(BC) image.
 Its using the MultiFormatWriter for reading the bar code image. 
 Calling application should be register for notification(NSNotificationWriteSuccess).
 After successfully Writing this framework post the notification with dictionary object containing nil value.
 */

#import <JavaVM/jni.h>
#import <JavaVM/JavaVM.h>
#import <Cocoa/Cocoa.h>

@interface WriteBarCode : NSObject
{
    NSString*       _path;                  //Path to file
    NSString*       _text;                  //Text to convert into bar code image
    NSString*       _extension;             //Type of image format
    NSString*       _format;                //Bar Code Format
    
    NSThread*       _creatingThread;        //Thread for creating bar code image
    
    jint            _width;                 //@:Width of Image
    jint            _height;                //@:Height of Image
}

@property (nonatomic, retain) NSString* path;
@property (nonatomic, retain) NSString* text;
@property (nonatomic, retain) NSString* extension;
@property (nonatomic, retain) NSString* format;
@property (nonatomic, assign) jint width;
@property (nonatomic, assign) jint height;

- (void) createBCImage;

@end
