//
//  ReadView.m
//  BarCodeScanning
//
//  Created by Yogesh Arora on 21/12/12.
//  Copyright (c) 2012 __MyCompanyName__. All rights reserved.
//

#import "ImageView.h"
#import "BarCodeFramework/ReadBarCode.h"
#import "AppDelegate.h"
#import "ReadView.h"

@interface ReadView()

- (void) registerNotification;

@end

@implementation ReadView

#pragma Mark - Button Action

- (IBAction) readBtnAction:(id)sender
{
    if ([_gAppDelegate filePath] == nil)
    {
        //showing alert if path nil
        NSAlert* alert = [NSAlert alertWithMessageText:@"Missing File" defaultButton:nil alternateButton:nil otherButton:nil informativeTextWithFormat:@"File not found"];
        [alert runModal]; 
    }
    else
    {
        [self registerNotification];
        [_outputLbl setStringValue:@"Progressing....."];
        
        //Start reading from filePath
        ReadBarCode* readBC = [[ReadBarCode alloc] init];
        [readBC setPath:[_gAppDelegate filePath]];
        [readBC readBCImage];
        [readBC release];
    }
}

#pragma Mark - Private Methods
//Invoke when application recieved notification 
- (void) handleNotification:(NSNotification*)note
{
    if ([note object] != nil)
    {
        if ([[[note object] valueForKey:@"Result"] isEqualToString:@"Ok"])
        {
            //Succeeded
            [_outputLbl setStringValue:@"Success"];
            [_barTextLbl setStringValue:[[note object] objectForKey:@"Text"]];
            [_barFormatLbl setStringValue:[[note object] objectForKey:@"Type"]];
            [_excepLbl setStringValue:@""];
        }
        else
        {
            //Fail
            [_outputLbl setStringValue:[NSString stringWithFormat:@"Fail: Error Code: %@", [[note object] objectForKey:@"Error_Code"]]];
            [_excepLbl setStringValue:[[note object] objectForKey:@"Error_Type"]];
        }
    }
    [[NSNotificationCenter defaultCenter] removeObserver:self];
}

//This method register the application to recieve notification for error and writing success
- (void) registerNotification
{
    //Register for recieving notification
    [[NSNotificationCenter defaultCenter]  addObserver:self
                                              selector:@selector(handleNotification:)
                                                  name:@"NSNotificationReadSuccess"
                                                object:nil];
    [[NSNotificationCenter defaultCenter]  addObserver:self
                                              selector:@selector(handleNotification:)
                                                  name:@"NSNotificationErrorRecieved"
                                                object:nil];
}

- (void) dealloc
{
    [_barTextLbl release];
    [_barFormatLbl release];
    [_outputLbl release];
    [_excepLbl release];
    
    [super dealloc];
}
@end
